import std.date;

import datestringbuilder;
import util;

class DateStringBuilderEng : DateStringBuilder
{
	override wchar[] monthString(const int len, const bool initialcap, const bool othercap)
	{
		switch(len)
		{
		case 1: // 2と共通
		case 2:
			return super.monthString(len, initialcap, othercap);
		case 3:
			return toUpper(m_month_abbr[month].dup, initialcap, othercap);
		case 4:
			return toUpper(m_month[month].dup, initialcap, othercap);
		default:
			throw new Exception("keyword error : 「m」の数が不正");
		}
	}
	
	override wchar[] dayString(const int len, const bool initialcap, const bool othercap)
	{
		switch(len)
		{
		case 3:
			return toUpper(m_days_abbr[day].dup, initialcap, othercap);
		case 4:
			return toUpper(m_days[day].dup, initialcap, othercap);
		default:
			throw new Exception("keyword error : 「d」の数が不正");
		}
	}
	
	override wchar[] meridiemString(const int len, const bool initialcap, const bool othercap)
	{
		wstring[] meridiems;
		
		if(len == 1)
			meridiems = m_meridiems_abbr;
		else if(len == 2)
			meridiems = m_meridiems;
		else
			throw new Exception("keyword error : 「t」の数が不正");
		
		if(isPM() )
			return toUpper(meridiems[1].dup, initialcap, initialcap);
		else
			return toUpper(meridiems[0].dup, initialcap, initialcap);
	}

private:
	const wstring[] m_month_abbr = ["jan"w, "feb"w, "mar"w, "apr"w, "may"w, "jun"w, "jul"w, "aug"w, "sep"w, "oct"w, "nov"w, "dec"w,];
	const wstring[] m_month = ["january"w, "february"w, "march"w, "april"w, "may"w, "june"w, "july"w, "august"w, "september"w, "october"w, "november"w, "december"w];
	const wstring[] m_days_abbr = ["sun"w, "mon"w, "tue"w, "wed"w, "thu"w, "fri"w, "sat"w];
	const wstring[] m_days = ["sunday"w, "monday"w, "tuesday"w, "wednesday"w, "thursday"w, "friday"w, "saturday"w];
	const wstring[] m_meridiems_abbr = ["am"w, "pm"w];
	const wstring[] m_meridiems = ["a.m."w, "p.m."w];
}
