import std.utf;

import util;
import datestringbuilder;
import datestringbuilderjpn;
import datestringbuildereng;
import datestringbuilderjpnk;

class DateStringBuilderFactory
{
public:
	static DateStringBuilder create(wstring locale)
	{
		if(locale is null)
			return new DateStringBuilderJpn();
		else if(locale.length == 0)
			throw new Exception("locale error : 地域指定が空");

		switch(locale)
		{
		case "jpn":
			return new DateStringBuilderJpn();
		case "jpn:k":
			return new DateStringBuilderJpnK();
		case "eng":
			return new DateStringBuilderEng();
		default:
			throw new Exception("locale error : 未対応の地域 " ~ toUTF8(locale) );
		}
	}
}
