import std.date;

import datestringbuilder;

class DateStringBuilderJpn : DateStringBuilder
{
	override wchar[] yearString(const int len, const bool initialcap, const bool othercap)
	{
		return super.yearString(len, initialcap, othercap);
	}
	
	override wchar[] monthString(const int len, const bool initialcap, const bool othercap)
	{
		switch(len)
		{
		case 1: // 2と共通
		case 2:
			return super.monthString(len, initialcap, othercap);
		case 3: // 4と共通
		case 4:
			return m_month[month].dup;
		default:
			throw new Exception("keyword error : 「m」の数が不正");
		}
	}
	
	override wchar[] dayString(const int len, const bool initialcap, const bool othercap)
	{
		if(len != 3 && len != 4)
			throw new Exception("keyword error : 「d」の数が不正");
		
		return m_days[day .. day + 1].dup;
	}
	
	override wchar[] meridiemString(const int len, const bool initialcap, const bool othercap)
	{
		if(len != 1 &&len != 2)
			throw new Exception("keyword error : 「t」の数が不正");
		
		if(isPM() )
			return m_meridiems[1].dup;
		else
			return m_meridiems[0].dup;
	}
	
private:
	const wstring[] m_month = ["睦月"w, "如月"w, "弥生"w, "卯月"w, "皐月"w, "水無月"w, "文月"w, "葉月"w, "長月"w, "神無月"w, "霜月"w, "師走"w];
	const wstring m_days = "日月火水木金土"w;
	const wstring[] m_meridiems = ["午前"w, "午後"w];
}
