import std.date;

import util;
import datestringbuilder;
import datestringbuilderjpn;

class DateStringBuilderJpnK : DateStringBuilderJpn
{
	this()
	{
		fill_char = '〇';
	}
	
	override wchar fill_char()
	{
		return super.fill_char;
	}
	
	override wchar fill_char(wchar value)
	{
		if(value == wchar.init)
			return super.fill_char = '〇';
		else
			return super.fill_char = value;
	}
	
	override wchar[] yearString(const int len, const bool initialcap, const bool othercap)
	{
		if(len != 1 && len != 2 && len != 4)
			throw new Exception("keyword error : 「y」の数が不正");

		int yeartmp = year - base_year;
		if(yeartmp == 1 && !initialcap)
			return "元"w.dup;
		return toWCharArrayK(yeartmp, initialcap, len, fill_char);
	}
	
	override wchar[] monthString(const int len, const bool initialcap, const bool othercap)
	{
		switch(len)
		{
		case 1: // 2と共通
		case 2:
			return toWCharArrayK(month + 1, initialcap, len, fill_char);
		default:
			return super.monthString(len, initialcap, othercap);
		}
	}
	
	override wchar[] dateString(const int len, const bool initialcap, const bool othercap)
	{
		if(len != 1 && len != 2)
			throw new Exception("keyword error : 「d」の数が不正");
		
		return toWCharArrayK(date, initialcap, len, fill_char);
	}

	override wchar[] hourString(const int len, const bool initialcap, const bool othercap)
	{
		if(len != 1 && len != 2)
			throw new Exception("keyword error : 「h」の数が不正");
		
		int hourtmp = hour;
		
		if(use_meridiem && isPM() )
		{
			hourtmp -= 12;
		}
		
		return toWCharArrayK(hourtmp, initialcap, len, fill_char);
	}
	
	override wchar[] minuteString(const int len, const bool initialcap, const bool othercap)
	{
		if(len != 1 && len != 2)
			throw new Exception("keyword error : 「n」の数が不正");
		
		return toWCharArrayK(minute, initialcap, len, fill_char);
	}
	
	override wchar[] secondString(const int len, const bool initialcap, const bool othercap)
	{
		if(len != 1 && len != 2)
			throw new Exception("keyword error : 「s」の数が不正");
		
		return toWCharArrayK(second, initialcap, len, fill_char);
	}
}
