import std.cstream;
import std.utf;
import win32.core;

import util;

void write_error(string msg)
{
	write_error(toUTF16(msg) );
}

void write_error(wstring msg)
{
	string mbsmsg = toMBS(msg);
	
	try
	{
		derr.writeLine(mbsmsg);
	}
	catch
	{
		mbsmsg ~= "\0";
		MessageBox(null, cast(char*)mbsmsg, cast(char*)"time2clipboard\0", MB_OK | MB_ICONWARNING);
	}
}

class ErrorLog
{
public:
	void add(wstring msg)
	{
		const int last = m_log.length;
		if(last == LIMIT_NUM)
		{
			m_log[$ - 1] = "too many errors."w;
		}
		else
		{
			m_log.length = last + 1;
			m_log[last] = msg;
		}
	}
	
	void add(string msg)
	{
		add(toUTF16(msg) );
	}
	
	void add(Exception exc)
	{
		add(exc.toString() );
	}
	
	void add(ErrorLog other)
	{
		this.m_log ~= other.m_log;
		
		if(this.m_log.length > LIMIT_NUM)
		{
			this.m_log.length = LIMIT_NUM;
			this.m_log[$ - 1] = "too many errors."w;
		}
	}
	
	bool isEmpty()
	{
		return m_log.length == 0;
	}
	
	wstring toWStringAll()
	{
		wstring res;
		
		foreach(str ; m_log)
		{
			res ~= str ~ "\r\n"w;
		}
		
		return res;
	}
	
private:
	static const int LIMIT_NUM = 16;
	
	wstring[] m_log;
}

class LoggedException : Exception
{
public:
	this(ErrorLog log)
	{
		super("LoggedException");
		
		if(log is null)
			log = new ErrorLog();
		
		m_log = log;
	}
	
	ErrorLog log()
	{
		return m_log;
	}
	
private:
	ErrorLog m_log;
}
