module test.util_test;

import std.cstream;
import std.stdio;
import std.utf;
import std.string;

import util;
import test.test_out;

void util_test_start()
{
	test_toInteger();
	//test_toWCharArray();
	//test_toWCharArrayK();
	//test_toLower();
	//test_toUpper1();
	//test_toUpperStr();
	//test_toWChar();
}

void test_toInteger()
{
	wstring value;
	int i;
	string testout;
	
	write_log("* 入力値がnull"w);
	try{
		value = null;
		i = toInteger(value);
		testout = format(" value %s => output %s", value, i);
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 正常系 : 0"w);
	try{
		value = "0"w;
		i = toInteger(value);
		testout = format(" value %s => output %s", value, i);
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 正常系 : 0"w);
	try{
		value = "0000"w;
		i = toInteger(value);
		testout = format(" value %s => output %s", value, i);
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 正常系 : 正の値"w);
	try{
		value = "1"w;
		i = toInteger(value);
		testout = format(" value %s => output %s", value, i);
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 正常系 : 正の値"w);
	try{
		value = "1234567890"w;
		i = toInteger(value);
		testout = format(" value %s => output %s", value, i);
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 正常系 : 正の値、先頭0"w);
	try{
		value = "0001234"w;
		i = toInteger(value);
		testout = format(" value %s => output %s", value, i);
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 正常系 : 正の値(オーバーフローはノーチェックだが、例外が発生しないこと)"w);
	try{
		value = "12345678900000000000000000"w;
		i = toInteger(value);
		testout = format(" value %s => output %s", value, i);
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 正常系 : 負の値"w);
	try{
		value = "-1"w;
		i = toInteger(value);
		testout = format(" value %s => output %s", value, i);
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 正常系 : 負の値"w);
	try{
		value = "-123456789"w;
		i = toInteger(value);
		testout = format(" value %s => output %s", value, i);
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 正常系 : 負の値、先頭0"w);
	try{
		value = "-0001234"w;
		i = toInteger(value);
		testout = format(" value %s => output %s", value, i);
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 正常系 : 負の値(オーバーフローはノーチェックだが、例外が発生しないこと)"w);
	try{
		value = "-1234567890000000000000000"w;
		i = toInteger(value);
		testout = format(" value %s => output %s", value, i);
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 1文字目数字以外"w);
	try{
		value = "a000"w;
		i = toInteger(value);
		testout = format(" value %s => output %s", value, i);
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 2文字目数字以外"w);
	try{
		value = "0a00"w;
		i = toInteger(value);
		testout = format(" value %s => output %s", value, i);
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* マイナス記号 + 1文字目数字以外"w);
	try{
		value = "-a000"w;
		i = toInteger(value);
		testout = format(" value %s => output %s", value, i);
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* マイナス記号 + 2文字目数字以外"w);
	try{
		value = "-0a00"w;
		i = toInteger(value);
		testout = format(" value %s => output %s", value, i);
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
}

void test_toWCharArray()
{
	wchar[] dst;
	
	write_log(" 桁数チェック -1"w);
	try{
		dst = toWCharArray(555, -1, '*');
	}catch(Exception exc){write_log(exc.toString() );}
	write_log(" 桁数チェック 0"w);
	try{
		dst = toWCharArray(555, 0, '*');
	}catch(Exception exc){write_log(exc.toString() );}
	write_log(" 桁数チェック 1"w);
	try{
		dst = toWCharArray(555, 1, '*');
	}catch(Exception exc){write_log(exc.toString() );}
	write_log(" 桁数チェック 9"w);
	try{
		dst = toWCharArray(555, 9, '*');
	}catch(Exception exc){write_log(exc.toString() );}
	write_log(" 桁数チェック 10"w);
	try{
		dst = toWCharArray(555, 10, '*');
	}catch(Exception exc){write_log(exc.toString() );}

	write_log("* 入力値チェック -1"w);
	try{
		dst = toWCharArray(-1, 9, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック 1234567890"w);
	try{
		dst = toWCharArray(1234567890, 9, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}

	write_log("* 入力値チェック4桁 0"w);
	try{
		dst = toWCharArray(0, 4, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック4桁 1"w);
	try{
		dst = toWCharArray(1, 4, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック4桁 10"w);
	try{
		dst = toWCharArray(10, 4, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック4桁 120"w);
	try{
		dst = toWCharArray(120, 4, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック4桁 3040"w);
	try{
		dst = toWCharArray(3040, 4, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック4桁 54321"w);
	try{
		dst = toWCharArray(54321, 4, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}

	write_log("* 入力値チェック9桁 0"w);
	try{
		dst = toWCharArray(0, 9, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック9桁 1"w);
	try{
		dst = toWCharArray(1, 9, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック9桁 10"w);
	try{
		dst = toWCharArray(10, 9, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック9桁 120"w);
	try{
		dst = toWCharArray(120, 9, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック9桁 3040"w);
	try{
		dst = toWCharArray(3040, 9, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック9桁 54321"w);
	try{
		dst = toWCharArray(54321, 9, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック9桁 678901"w);
	try{
		dst = toWCharArray(678901, 9, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック9桁 123456789"w);
	try{
		dst = toWCharArray(123456789, 9, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}

	write_log("* 入力値チェック桁指定なし 0"w);
	try{
		dst = toWCharArray(0, 1, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック桁指定なし 1"w);
	try{
		dst = toWCharArray(1, 1, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック桁指定なし 10"w);
	try{
		dst = toWCharArray(10, 1, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック桁指定なし 120"w);
	try{
		dst = toWCharArray(120, 1, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック桁指定なし 3040"w);
	try{
		dst = toWCharArray(3040, 1, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック桁指定なし 54321"w);
	try{
		dst = toWCharArray(54321, 1, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック桁指定なし 678901"w);
	try{
		dst = toWCharArray(678901, 1, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* 入力値チェック桁指定なし 123456789"w);
	try{
		dst = toWCharArray(123456789, 1, '*');
		write_log(dst);
	}catch(Exception exc){write_log(exc.toString() );}
}

void test_toWCharArrayK()
{
	wchar[] dst;
	string testout;
	
	write_log("*[零] : use0を指定しない場合、桁数は無視"w);
	try{
		dst = toWCharArrayK(0, false, -1, '※');
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("*[〇] : 桁数チェック -1"w);
	try{
		dst = toWCharArrayK(0, true, -1, '※');
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("*[〇] : 桁数チェック 0"w);
	try{
		dst = toWCharArrayK(0, true, 0, '※');
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("*[〇] : 桁数チェック 1"w);
	try{
		dst = toWCharArrayK(0, true, 1, '※');
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("*[〇] : 桁数チェック 4"w);
	try{
		dst = toWCharArrayK(0, true, 4, '※');
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("*[〇] : 桁数チェック 5"w);
	try{
		dst = toWCharArrayK(0, true, 5, '※');
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* : 入力値チェック -1"w);
	try{
		dst = toWCharArrayK(-1, true, 4, '※');
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* : 入力値チェック 0"w);
	try{
		dst = toWCharArrayK(0, true, 4, '※');
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* : 入力値チェック 1"w);
	try{
		dst = toWCharArrayK(1, true, 4, '※');
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* : 入力値チェック 9999"w);
	try{
		dst = toWCharArrayK(9999, true, 4, '※');
	}catch(Exception exc){write_log(exc.toString() );}
	write_log("* : 入力値チェック 10000"w);
	try{
		dst = toWCharArrayK(10000, true, 4, '※');
	}catch(Exception exc){write_log(exc.toString() );}

/*
	write_log("*[零]"w);
	for(int i = -1; i <= 10000; i++)
	{
		try{
			dst = toWCharArrayK(i, false, -1, '※');
			
			write_log(std.utf.toUTF16(format("%05s : ",i) ) ~ dst);
		}catch(Exception exc){write_log(exc.toString() );}
	}

	write_log("*[〇]"w);
	for(int i = -1; i <= 10000; i++)
	{
		try{
			dst = toWCharArrayK(i, true, 4, '※');
			
			write_log(std.utf.toUTF16(format("%05s : ",i) ) ~ dst);
		}catch(Exception exc){write_log(exc.toString() );}
	}
*/

	
}

void test_toLower()
{
	wchar[] src = new wchar[128];
	for(int i = 0; i < src.length; i++)
	{
		src[i] = i + 20;
	}
	wstring dst;
	
	try{
		write_log("* 空の文字列"w);
		dst = toLower(null);
		write_log(src ~ " => " ~ dst);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 正常系"w);
	dst = toLower(src.idup);
	write_log(src ~ " => " ~ dst);
}

void test_toUpper1()
{
	wchar[128] src;
	wchar[128] dst;
	for(int i = 0; i < src.length; i++)
	{
		src[i] = i + 20;
		dst[i] = toUpper(src[i] );
	}
	
	write_log("* 1文字"w);
	write_log(src);
	write_log(dst);
}

void test_toUpperStr()
{
	wchar[] str;
	
	try{
		write_log("* 空の文字列"w);
		str = null;
		toUpper(str, true, true);
		write_log(str);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 変更なし"w);
	str = "test0123"w.dup;
	toUpper(str, false, false);
	write_log(str);
	
	write_log("* 変更対象なし(1文字目)"w);
	str = "Test0123"w.dup;
	toUpper(str, true, false);
	write_log(str);
	
	write_log("* 変更対象なし(2文字目以降)"w);
	str = "tEST0123"w.dup;
	toUpper(str, false, true);
	write_log(str);
	
	write_log("* 1文字目大文字、以降小文字"w);
	str = "teSt0123"w.dup;
	toUpper(str, true, false);
	write_log(str);
	
	write_log("* 1文字目小文字、以降大文字"w);
	str = "teSt0123"w.dup;
	toUpper(str, false, true);
	write_log(str);
	
	write_log("* 全体大文字"w);
	str = "teSt0123"w.dup;
	toUpper(str, true, true);
	write_log(str);
}

void test_toWChar()
{
	wchar ch;
	wstring teststr;
	string testout;
	
	write_log("* nullを渡す"w);
	try{
		teststr = null;
		ch = toWChar(teststr);
		testout = format("input %s => output %04x(%s)", teststr, ch, char2str(ch) );
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 空の文字列を渡す"w);
	try{
		teststr = "";
		ch = toWChar(teststr);
		testout = format("input %s => output %04x(%s)", teststr, ch, char2str(ch) );
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 文字数不足"w);
	try{
		teststr = "000";
		ch = toWChar(teststr);
		testout = format("input %s => output %04x(%s)", teststr, ch, char2str(ch) );
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 正常系0000"w);
	try{
		teststr = "0000";
		ch = toWChar(teststr);
		testout = format("input %s => output %04x(%s)", teststr, ch, char2str(ch) );
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 正常系72fd"w);
	try{
		teststr = "72fd";
		ch = toWChar(teststr);
		testout = format("input %s => output %04x(%s)", teststr, ch, char2str(ch) );
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 正常系72FD"w);
	try{
		teststr = "72FD";
		ch = toWChar(teststr);
		testout = format("input %s => output %04x(%s)", teststr, ch, char2str(ch) );
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 16進数以外"w);
	try{
		teststr = "89AZ";
		ch = toWChar(teststr);
		testout = format("input %s => output %04x(%s)", teststr, ch, char2str(ch) );
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
	
	write_log("* 5文字目を無視するか"w);
	try{
		teststr = "4f592";
		ch = toWChar(teststr);
		testout = format("input %s => output %04x(%s)", teststr, ch, char2str(ch) );
		write_log(testout);
	}catch(Exception exc){write_log(exc.toString() );}
}
