import std.cstream;
import std.date;
import win32.core;
import win32.mmsystem;

import commandline;
import util;
import datestringbuilderfactory;
import datestringbuilder;
import error;

void main(string[] args)
{
	try
	{
		CommandLine cmdlin = new CommandLine(args);
		DateStringBuilder dsb = DateStringBuilderFactory.create(cmdlin.locale);
		
		dsb.base_year = cmdlin.base_year;
		dsb.fill_char = cmdlin.fill_char;
		dsb.use_meridiem = cmdlin.use_meridiem;
		dsb.format = cmdlin.format;
		dsb.time = UTCtoLocalTime(getUTCtime() );
		wstring outstr = dsb.toWString();
		
		setClipboard(outstr);
		dout.writeLine(toMBS(outstr) );
		
		//MessageBeep(MB_OK);
		PlaySound(cast(char*)"se.wav", null, SND_FILENAME);
	}
	catch(LoggedException lexc)
	{
		write_error(lexc.log.toWStringAll() );
	}
	catch(Exception exc)
	{
		write_error(exc.toString() );
	}
}
